package dev.boyfailure.quajra.vectorbreakout;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import javax.swing.JFrame;
import javax.swing.Timer;

public class VectorBreakout {
    
    // The embeddable game
    public static GameState gameState = new GameState();

    // The window for the game
    public static JFrame gameFrame = new JFrame();
    public static GameDisplay gameCanvas = new GameDisplay(gameState);

    public VectorBreakout() {
    }
    
    public static void main(String[] args) {

        // Enable OpenGL for hardware acceleration
        System.setProperty("sun.java2d.opengl", "true");

        // Set the game window's properties
        gameFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        gameFrame.setTitle(gameState.gameName);
        gameFrame.setSize(gameState.gameResX, gameState.gameResY);
        gameFrame.getContentPane().setBackground(Color.black);
        gameFrame.getContentPane().add(gameCanvas);
        gameFrame.setVisible(true);
        
        gameFrame.addKeyListener(gameState.getKeyListener());

        // Adapts vector drawing scale when the window is resized 
        gameFrame.addComponentListener(new ComponentAdapter() {
            public void componentResized(ComponentEvent componentEvent) {
                GameDisplay.beamScaleX = gameFrame.getBounds().width / 800f;
                GameDisplay.beamScaleY = gameFrame.getBounds().height / 600f;
            }
        });

        Timer gameTick = new Timer((1000 / gameState.getGameTickRate()), gameState.getGameTickActionListener());
        gameTick.start();

        Timer frameDisplay = new Timer((1000 / gameState.getTargetFrameRate()), new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                gameState.incrementFrameCounter();
                gameFrame.repaint();
            }
        });
        frameDisplay.start();

        Timer gameCuller = new Timer(1000, gameState.getGameStateUpdateActionListener());
        gameCuller.start();

    }
    
}
